import ini;

import screen;
import std.string;

const int TILE_SIZE = 32;

class Map{
  public:
	// returns the closest point it can move to in the path (in pixels)

	this(char[] filename){
		fn = filename;

		load(filename);
	}

	void load(char[] filename){
		void delegate(char[], char[]) v;
		Tile*[char[]] t;


		void generalValue(char[] name, char[] val){
			switch(name){
//			  case "canwalk":
//				t.walkable = toBool(val);
//			  break;
			}
		}

		void tilesValue(char[] name, char[] val){
			if(name.length > 1)
				throw new Exception("The tile name here should be a single letter.");
			t[name] = val in tiles;
		}

		void monstersValue(char[] name, char[] val){
		}

		void terrainValue(char[] name, char[] val){
			switch(name){
			  case "width":
				width = atoi(val);
			  break;
			  case "height":
			  	height = atoi(val);
			  break;
			  case "data":
				if(width == 0 || height == 0)
					throw new Exception("Width and height need to be specified first.");

				terrain = new Tile*[width * height];
				int off = 0;

				foreach(part; val){
					if(part == ' ' || part == '\n' || part == '\t')
						continue;

					char[1] lol;
					lol[0] = part;
					Tile** a = lol in t;
					if(a is null)
						throw new Exception("No such tile listed");
					if(off >= width * height)
						throw new Exception("Too much data");
					terrain[off] = *a;
					off++;
				}
			  break;
			}
		}

		void value(char[] name, char[] val){
			if(v is null)
				throw new Exception("no section");

			v(name, val);
		}


		void section(char[] name){
			switch(name){
			  case "tiles":
				v = &tilesValue;
			  break;
			  case "terrain":
				v = &terrainValue;
			  break;
			  case "general":
				v = &generalValue;
			  break;
			  case "monsters":
				v = &monstersValue;
			  break;
			}
		}

		loadINI(filename, &section, &value);

	}


	Point canMove(Point from, Point to, Image c){
		int dx = to.x - from.x;
		int dy = to.y - from.y;

		int x, y;

		if(dx > 0)
			x = from.x + c.width;
		else
			x = from.y;

		if(dy > 0)
			y = from.y + c.height;
		else
			y = from.y;

		if(isWalkable(to.x, to.y))
			return to;
		else
			return from;
	}


	int canMoveL(int x, int y, int want, Image p){
		for(int a = 0; a <= want; a++)
			if(!(isWalkable(x - a, y) && isWalkable(x - a, y + p.height - 1)))
				return a==0 ? 0 : a-1;

		return want;
	}
	int canMoveR(int x, int y, int want, Image p){
		x += p.width -1;
//		for(int a = want; a > 0; a--)
		for(int a = 0; a <= want; a++)
			if(!isWalkable(x + a, y) || !isWalkable(x + a, y + p.height - 1))
				return a==0 ? 0 : a-1;

		return want;
	}
	int canMoveU(int x, int y, int want, Image p){
		for(int a = 0; a <= want; a++)
			if(!(isWalkable(x, y - a) && isWalkable(x + p.width - 1, y -a)))
				return a==0 ? 0 : a-1;

		return want;
	}
	int canMoveD(int x, int y, int want, Image p){
		y += p.height-1;
		for(int a = 0; a <= want; a++)
			if(!(isWalkable(x, y + a) && isWalkable(x + p.width - 1, y + a)))
				return a==0 ? 0 : a-1;

		return want;
	}


	bool isWalkable(int x, int y){
		int X = x / TILE_SIZE;
		int Y = y / TILE_SIZE;

		if(X >= width || X < 0 || Y >= height || Y < 0)
			return false;

		return terrain[Y * width + X].walkable;
	}

	void adjustUL(Point* p){
		if(p.x < 0)
			p.x = 0;
		if(p.y < 0)
			p.y = 0;
		if(p.x + 640 >= width * TILE_SIZE)
			p.x = width * TILE_SIZE - 640;
		if(p.y + 480 >= height * TILE_SIZE)
			p.y = height * TILE_SIZE - 480;
	}
	// upper left x, y, in pixels
	void draw(Painter p, int x, int y){
		if(x < 0)
			x = 0;
		if(y < 0)
			y = 0;
		int mapx = x / TILE_SIZE;
		int mapy = y / TILE_SIZE;

		int sx = -TILE_SIZE - x % TILE_SIZE + TILE_SIZE;
		int sy = -TILE_SIZE - y % TILE_SIZE + TILE_SIZE;
	//	if(sx == -TILE_SIZE)
	//		sx = 0;
	//	if(sy == - TILE_SIZE)
	//		sy = 0;
		Point l = XY(sx, sy);

		int offset = mapy*width + mapx;

		for(int b = 0; b < 480 / TILE_SIZE + 2; b++){
			if(mapy >= 0)
			for(int a = 0; a < 640 / TILE_SIZE + 2; a++){
				if(mapx >= 0)
					p.drawImage(l, terrain[offset].pic, TILE_SIZE, TILE_SIZE);
				
				offset++;

				mapx++;
				if(mapx >= width){
					mapx = x / TILE_SIZE;
					break;
				}

				l.x += TILE_SIZE;
			}

			l.x = sx;
			l.y += TILE_SIZE;

			mapy++;
			mapx = x / TILE_SIZE;

			offset = mapy*width + mapx;

			if(mapy >= height)
				break;
		}
	}
  private:
	int width;  // in tiles
	int height; // in tiles

	Tile*[] terrain;

	char[] fn;
}



struct Tile{
	Image pic;

	bool walkable;
	bool breakable;
}


Tile[char[]] tiles;
void loadTiles(){
	Tile* t;
	char[] n;

	void commit(){
		if(t !is null){
			t.pic = new Image(n ~ ".png");
			tiles[n] = *t;
		}
	}

	void section(char[] name){
		commit;
		n = name;
		t = new Tile;
	}

	void value(char[] name, char[] val){
		switch(name){
		  case "canwalk":
		  case "walkable":
			t.walkable = toBool(val);
		  break;
		  case "breakable":
		  case "canbreak":
		  	t.breakable = toBool(val);
		  break;
		}
	}


	loadINI("tiles.txt", &section, &value);

	commit;
}

static ~this(){
	foreach(tile; tiles)
		delete tile.pic;
}


/*
void loadINI(char[] filename, 
	     void delegate(char[] name) encounteredSection,
	     void delegate(char[] name, char[] value) encounteredValue
*/
