import engine;

import std.file;
import std.stdio;
import std.gc;

import std.math;
import std.string;

import map;

bool wantSound = false;
bool wantAI = true;

void readConfig(){
	char[] text = cast(char[]) std.file.read("config.txt");
	if(std.string.find(text,"sound=yes") != -1)
		wantSound = true;
	if(std.string.find(text,"fullscreen=yes") != -1)
		wantFullScreen = true;
	if(std.string.find(text,"ai=no") != -1)
		wantAI = false;
}

bool wantTitle = false;
bool wantFullScreen = false;
bool wantGrab = false;

void main(char[][] args){
	version(Windows)
		std.gc.disable;
	foreach(arg; args){
		if(arg == "--title-screen")
			wantTitle = true;
		if(arg == "--capture-input")
			wantGrab = true;
		if(arg == "--no-ai")
			wantAI = false;
	}


	readConfig;

	Engine engine = new S;
	scope(exit) delete engine;


	try
		engine.run;
	catch (Exception e)
		e.print;
	finally
		fullCollect();
}

class S : Engine{
this(){
	super( Video640x480 | (wantFullScreen ? VideoFullScreen : 0), wantSound, 50, true);


	FontEngine.instance.loadFont("sans-serif.ttf", 12);
	FontEngine.instance.loadFont("sans-serif.ttf", 26,3);

	setTitle("Scroller");

	if(wantGrab)
		captureInput();


	loadTiles;
	map = new Map("map.txt");

	normalPlayer = new Image("player.png");
	player = normalPlayer;
	duckingPlayer = new Image("player_ducking.png");


	Yeah y = new Yeah;
	y.start;
}

Map map;
Image player, duckingPlayer, normalPlayer;

class Yeah : Callable{


/////////////////////////////////////////////////////////

void changePlayer(Image p){
	py += player.height - p.height;
	player = p;
}


int px = 0;
int py = 480 - 64 - 32;
int dx;
int dy;

int speed = 2;
int maxspeed = 9;
int jump  = 30;
int gravity = 4;


	void run(int timer){
		if(dx > 0)
			dx--;
		if(dx < 0)
			dx++;

//		if(dy < 0)
/+
		if(py <  480 - 64 - 32 - 1)
		dy += gravity;
		if(py > 480 - 64 - 32 - 1)
			py = 480 - 64 - 32 - 1;
+/

		if(buttonWasPressed(circle) && dy == 0)
			dy -= jump;

		dy += gravity;

		if(directionIsDown(right))
			dx += speed;
		if(directionIsDown(left))
			dx -= speed;
//		if(directionIsDown(up))
//			py -= speed;
		if(directionIsDown(down))
			changePlayer(duckingPlayer);
		else
			changePlayer(normalPlayer);
//			py += speed;



		if(dx < -maxspeed)
			dx = -maxspeed;
		if(dx > maxspeed)
			dx = maxspeed;




		int rdx, rdy;

		if(dx > 0)
			rdx = map.canMoveR(px, py, abs(dx), player);
		if(dx < 0)
			rdx = -map.canMoveL(px, py, abs(dx), player);
		if(dy > 0)
			rdy = map.canMoveD(px, py, abs(dy), player);
		if(dy < 0)
			rdy = -map.canMoveU(px, py, abs(dy), player);

		if(rdx != dx)
			dx = rdx;
		if(rdy != dy)
			dy = rdy;

		px += dx;
		py += dy;

		if(px - ul.x > 400 && dx > 0)
			ul.x += dx;
		if(px - ul.x < 200 && dx < 0)
			ul.x += dx;

		if(py - ul.y > 360 && dy > 0)
			ul.y += dy;
		if(py - ul.y < 120 && dy < 0)
			ul.y += dy;

		map.adjustUL(&ul);

		scope Painter p = new Painter(screen);
		p.clear;

		map.draw(p, ul.x, ul.y);
		p.drawImage(XY(px, py) - ul, player);



		p.box(XY(0,0), XY(640, 20), RGB(0,0,0));
		p.drawTextf(XY(0,0), "Score: %08d", 123);
	}

Point ul;



/////////////////////////////////////////////////////////////
}
}
